%global leapp_datadir %{_datadir}/leapp-repository
%global repositorydir %{leapp_datadir}/repositories
%global custom_repositorydir %{leapp_datadir}/custom-repositories
%define leapp_repo_deps  9
%define leapp_python_sitelib %{python3_sitelib}
%define lpr_name leapp-upgrade-el8toel9
%global __requires_exclude ^python\\(abi\\) = 3\\..+|/usr/libexec/platform-python|/usr/bin/python.*

Name:           leapp-repository
Version:        0.18.0
Release:        309.oc8
Summary:        Repositories for leapp

License:        ASL 2.0
URL:            https://oamg.github.io/leapp/
Source0:        https://github.com/oamg/%{name}/archive/v%{version}.tar.gz#/%{name}-%{version}.tar.gz
Source1:        deps-pkgs-9.tar.gz
BuildArch:      noarch
Patch0001:      0001-modify_for_oc8_to_oc9.patch
Patch0002:      0002-modify_for_oc8_to_oc9.patch
Patch0003:      0003-modify_for_oc8_to_oc9.patch
Patch0004:      0004-modify_for_oc8_to_oc9.patch
Patch0005:      0005-modify_for_oc8_to_oc9.patch
Patch0006:      0006-modify_for_oc8_to_oc9.patch
Patch0007:      0007-modify_for_oc8_to_oc9.patch
Patch0008:      0008-modify_for_oc8_to_oc9.patch
Patch0009:      0009-modify_for_oc8_to_oc9.patch
Patch0010:      0010-modify_for_oc8_to_oc9.patch
Patch0011:      0011-modify_for_oc8_to_oc9.patch
Patch0012:      0012-modify_for_oc8_to_oc9.patch
Patch0013:      0013-modify_for_oc8_to_oc9.patch
Patch0014:      0014-modify_for_oc8_to_oc9.patch
Patch0015:      0015-modify_for_oc8_to_oc9.patch

%description
%{summary}


# This is the real RPM with the leapp repositories content
%package -n %{lpr_name}
Summary: Leapp repositories for the in-place upgrade

######### OpenCloudOS 8 ############
BuildRequires:  python3-devel
Requires:       python3-leapp
Conflicts:      leapp-upgrade-el7toel8
Requires:       leapp-repository-dependencies = %{leapp_repo_deps}
Requires:       leapp-framework >= 3.1
Requires:       leapp
Requires:   cpio
Obsoletes:      leapp-repository < 0.14.0-5
Provides:       leapp-repository = %{version}-%{release}
Provides:       leapp-upgrade = %{version}-%{release}
Provides:       leapp-command(answer)
Provides:       leapp-command(preupgrade)
Provides:       leapp-command(upgrade)
Provides:       leapp-command(rerun)
Provides:       leapp-command(list-runs)

%description -n %{lpr_name}
Leapp repositories for the in-place upgrade to the next major version
of the Red Hat Enterprise Linux system.

%package -n %{lpr_name}-deps
Summary:    Meta-package with system dependencies of %{lpr_name} package
Obsoletes:      leapp-repository-deps < 0.14.0-5
Provides:  leapp-repository-dependencies = %{leapp_repo_deps}
Requires:   dnf >= 4
Requires:   pciutils
Requires:   systemd-container
Requires:   python3-pyudev
Requires:   python3-requests
Requires:   python3-six
Requires:   policycoreutils-python-utils
Requires:   procps-ng
Requires:   kmod
Requires:   dracut
Requires:   NetworkManager-libnm
Requires:   python3-gobject-base

%description -n %{lpr_name}-deps
%{summary}


%prep
%setup -n %{name}-%{version}
%setup -q  -n %{name}-%{version} -D -T -a 1
%patch0001 -p1
%patch0002 -p1
%patch0003 -p1
%patch0004 -p1
%patch0005 -p1
%patch0006 -p1
%patch0007 -p1
%patch0008 -p1
%patch0009 -p1
%patch0010 -p1
%patch0011 -p1
%patch0012 -p1
%patch0013 -p1
%patch0014 -p1

%build
cp -a leapp*deps*el9.noarch.rpm repos/system_upgrade/el8toel9/files/bundled-rpms/

%install
install -m 0755 -d %{buildroot}%{custom_repositorydir}
install -m 0755 -d %{buildroot}%{repositorydir}
cp -r repos/* %{buildroot}%{repositorydir}/
install -m 0755 -d %{buildroot}%{_sysconfdir}/leapp/repos.d/
install -m 0755 -d %{buildroot}%{_sysconfdir}/leapp/transaction/
install -m 0755 -d %{buildroot}%{_sysconfdir}/leapp/files/
install -m 0644 etc/leapp/transaction/* %{buildroot}%{_sysconfdir}/leapp/transaction
install -m 0755 -d %{buildroot}%{_sysconfdir}/yum.repos.d/
install -m 0644 etc/leapp/files/* %{buildroot}%{_sysconfdir}/leapp/files
install -m 0644 etc/yum.repos.d/* %{buildroot}%{_sysconfdir}/yum.repos.d
install -m 0755 -d %{buildroot}%{leapp_python_sitelib}/leapp/cli/
cp -r commands %{buildroot}%{leapp_python_sitelib}/leapp/cli/
rm -rf %{buildroot}%{leapp_python_sitelib}/leapp/cli/commands/tests
rm -rf %{buildroot}%{repositorydir}/system_upgrade/el7toel8
rm -rf %{buildroot}%{repositorydir}/common/actors/testactor
find %{buildroot}%{repositorydir}/common -name "test.py" -delete
rm -rf `find %{buildroot}%{repositorydir} -name "tests" -type d`
find %{buildroot}%{repositorydir} -name "Makefile" -delete
find %{buildroot} -name "*.py.orig" -delete

for DIRECTORY in $(find  %{buildroot}%{repositorydir}/  -mindepth 1 -maxdepth 1 -type d);
do
    REPOSITORY=$(basename $DIRECTORY)
    echo "Enabling repository $REPOSITORY"
    ln -s  %{repositorydir}/$REPOSITORY  %{buildroot}%{_sysconfdir}/leapp/repos.d/$REPOSITORY
done;

%py_byte_compile %{__python3} %{buildroot}%{repositorydir}/*


%files -n %{lpr_name}
%doc README.md
%license LICENSE
%dir %{_sysconfdir}/leapp/transaction
%dir %{_sysconfdir}/leapp/files
%dir %{leapp_datadir}
%dir %{repositorydir}
%dir %{custom_repositorydir}
%dir %{leapp_python_sitelib}/leapp/cli/commands
%config %{_sysconfdir}/leapp/files/*
%{_sysconfdir}/leapp/repos.d/*
%{repositorydir}/*
%{leapp_python_sitelib}/leapp/cli/commands/*
%{_sysconfdir}/leapp/transaction/*
%{_sysconfdir}/yum.repos.d/*

%files -n %{lpr_name}-deps
# no files here

%changelog
* Wed Oct 11 2023 xiaoyunzhao <xiaoyunzhao@tencentos.com> - 0.18.0-309
- modify spec

* Wed Oct 11 2023 xiaoyunzhao <xiaoyunzhao@tencentos.com> - 0.18.0-308
- add gpgcheck in upgrading


* Wed Oct 11 2023 xiaoyunzhao <xiaoyunzhao@tencentos.com> - 0.18.0-307
- change the default boot mode


* Wed Oct 11 2023 xiaoyunzhao <xiaoyunzhao@tencentos.com> - 0.18.0-306
- delete the packages whose release include 'oc8'


* Wed Oct 11 2023 xiaoyunzhao <xiaoyunzhao@tencentos.com> - 0.18.0-305
- issue some packages：python3.11


* Tue Oct 10 2023 xiaoyunzhao <xiaoyunzhao@tencentos.com> - 0.18.0-304
- issue some packages：llvm-static,redis-doc,perf and trace-cmd


* Fri Sep 22 2023 xiaoyunzhao <xiaoyunzhao@tencentos.com> - 0.18.0-303
- get kernel release from yum


* Wed Sep 20 2023 xiaoyunzhao <xiaoyunzhao@tencentos.com> - 0.18.0-302
- no repackaging:opencloudsos-release


* Wed Sep 20 2023 xiaoyunzhao <xiaoyunzhao@tencentos.com> - 0.18.0-301
- modify the changes of RPM database between OC8 and OC9


* Wed Aug 16 2023 xiaoyunzhao <xiaoyunzhao@tencentos.com> - 0.18.0-300
- modify for upgrading oc8 to oc9
